<?php

namespace Drupal\synamo\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Implements the form controller.
 */
class AmoSettings extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'app_amo';
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return ['synamo.amo_form'];
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('synamo.amo_form');

    $form['auth'] = [
      '#type' => 'details',
      '#title' => $this->t('AmoCRM Auth'),
      '#open' => TRUE,
    ];

    $form['auth']['login'] = [
      '#title' => $this->t('Login'),
      '#default_value' => $config->get('login'),
      '#type' => 'textfield',
      '#description' => '',
    ];
    $form['auth']['hash'] = [
      '#title' => $this->t('Hash'),
      '#default_value' => $config->get('hash'),
      '#type' => 'textfield',
      '#description' => '',
    ];
    $form['auth']['subdomain'] = [
      '#title' => $this->t('Subdomain'),
      '#default_value' => $config->get('subdomain'),
      '#type' => 'textfield',
      '#description' => '',
    ];
    return parent::buildForm($form, $form_state);
  }

  /**
   * Implements a form submit handler.
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {

    $config = $this->config('synamo.amo_form');
    $config
      ->set('login', $form_state->getValue('login'))
      ->set('hash', $form_state->getValue('hash'))
      ->set('subdomain', $form_state->getValue('subdomain'))
      ->save();
  }

}
